diff --git a/package/utils/lua/Makefile b/package/utils/lua5.1/Makefile
similarity index 87%
rename from package/utils/lua/Makefile
rename to package/utils/lua5.1/Makefile
index ae4c0cb385..645250e441 100644
--- a/package/utils/lua/Makefile
+++ b/package/utils/lua5.1/Makefile
@@ -40,49 +40,52 @@ define Package/lua/Default/description
  language. Lua is free software.
 endef
 
-define Package/liblua
+define Package/liblua5.1
 $(call Package/lua/Default)
   SUBMENU:=
   SECTION:=libs
   CATEGORY:=Libraries
   TITLE+= (libraries)
+  PROVIDES:=liblua
   ABI_VERSION:=5.1.5
 endef
 
-define Package/liblua/description
+define Package/liblua5.1/description
 $(call Package/lua/Default/description)
  This package contains the Lua shared libraries, needed by other programs.
 endef
 
-define Package/lua
+define Package/lua5.1
 $(call Package/lua/Default)
-  DEPENDS:=+liblua
+  DEPENDS:=+liblua5.1
   TITLE+= (interpreter)
+  PROVIDES:=lua
 endef
 
-define Package/lua/description
+define Package/lua.1/description
 $(call Package/lua/Default/description)
  This package contains the Lua language interpreter.
 endef
 
-define Package/luac
+define Package/luac5.1
 $(call Package/lua/Default)
-  DEPENDS:=+liblua
+  DEPENDS:=+liblua5.1
   TITLE+= (compiler)
+  PROVIDES:=luac
 endef
 
-define Package/luac/description
+define Package/luac5.1/description
 $(call Package/lua/Default/description)
  This package contains the Lua language compiler.
 endef
 
-define Package/lua-examples
+define Package/lua5.1-examples
 $(call Package/lua/Default)
-  DEPENDS:=lua
+  DEPENDS:=lua5.1
   TITLE+= (examples)
 endef
 
-define Package/lua-examples/description
+define Package/lua5.1-examples/description
 $(call Package/lua/Default/description)
  This package contains Lua language examples.
 endef
@@ -164,15 +167,14 @@ define Package/luac/install
 	$(LN) luac5.1 $(1)/usr/bin/luac
 endef
 
-define Package/lua-examples/install
+define Package/lua5.1-examples/install
 	$(INSTALL_DIR) $(1)/usr/share/lua/examples
 	$(INSTALL_DATA) $(PKG_BUILD_DIR)/test/*.lua \
 		$(1)/usr/share/lua/examples/
 endef
 
-$(eval $(call BuildPackage,liblua))
-$(eval $(call BuildPackage,lua))
-$(eval $(call BuildPackage,luac))
-$(eval $(call BuildPackage,lua-examples))
+$(eval $(call BuildPackage,liblua5.1))
+$(eval $(call BuildPackage,lua5.1))
+$(eval $(call BuildPackage,luac5.1))
+$(eval $(call BuildPackage,lua5.1-examples))
 $(eval $(call HostBuild))
-
diff --git a/package/utils/lua/patches-host/001-include-version-number.patch b/package/utils/lua5.1/patches-host/001-include-version-number.patch
similarity index 100%
rename from package/utils/lua/patches-host/001-include-version-number.patch
rename to package/utils/lua5.1/patches-host/001-include-version-number.patch
diff --git a/package/utils/lua/patches-host/010-lua-5.1.3-lnum-full-260308.patch b/package/utils/lua5.1/patches-host/010-lua-5.1.3-lnum-full-260308.patch
similarity index 100%
rename from package/utils/lua/patches-host/010-lua-5.1.3-lnum-full-260308.patch
rename to package/utils/lua5.1/patches-host/010-lua-5.1.3-lnum-full-260308.patch
diff --git a/package/utils/lua/patches-host/011-lnum-use-double.patch b/package/utils/lua5.1/patches-host/011-lnum-use-double.patch
similarity index 100%
rename from package/utils/lua/patches-host/011-lnum-use-double.patch
rename to package/utils/lua5.1/patches-host/011-lnum-use-double.patch
diff --git a/package/utils/lua/patches-host/012-lnum-fix-ltle-relational-operators.patch b/package/utils/lua5.1/patches-host/012-lnum-fix-ltle-relational-operators.patch
similarity index 100%
rename from package/utils/lua/patches-host/012-lnum-fix-ltle-relational-operators.patch
rename to package/utils/lua5.1/patches-host/012-lnum-fix-ltle-relational-operators.patch
diff --git a/package/utils/lua/patches-host/013-lnum-strtoul-parsing-fixes.patch b/package/utils/lua5.1/patches-host/013-lnum-strtoul-parsing-fixes.patch
similarity index 100%
rename from package/utils/lua/patches-host/013-lnum-strtoul-parsing-fixes.patch
rename to package/utils/lua5.1/patches-host/013-lnum-strtoul-parsing-fixes.patch
diff --git a/package/utils/lua/patches-host/015-lnum-ppc-compat.patch b/package/utils/lua5.1/patches-host/015-lnum-ppc-compat.patch
similarity index 100%
rename from package/utils/lua/patches-host/015-lnum-ppc-compat.patch
rename to package/utils/lua5.1/patches-host/015-lnum-ppc-compat.patch
diff --git a/package/utils/lua/patches-host/030-archindependent-bytecode.patch b/package/utils/lua5.1/patches-host/030-archindependent-bytecode.patch
similarity index 100%
rename from package/utils/lua/patches-host/030-archindependent-bytecode.patch
rename to package/utils/lua5.1/patches-host/030-archindependent-bytecode.patch
diff --git a/package/utils/lua/patches-host/100-no_readline.patch b/package/utils/lua5.1/patches-host/100-no_readline.patch
similarity index 100%
rename from package/utils/lua/patches-host/100-no_readline.patch
rename to package/utils/lua5.1/patches-host/100-no_readline.patch
diff --git a/package/utils/lua/patches/001-include-version-number.patch b/package/utils/lua5.1/patches/001-include-version-number.patch
similarity index 100%
rename from package/utils/lua/patches/001-include-version-number.patch
rename to package/utils/lua5.1/patches/001-include-version-number.patch
diff --git a/package/utils/lua/patches/010-lua-5.1.3-lnum-full-260308.patch b/package/utils/lua5.1/patches/010-lua-5.1.3-lnum-full-260308.patch
similarity index 100%
rename from package/utils/lua/patches/010-lua-5.1.3-lnum-full-260308.patch
rename to package/utils/lua5.1/patches/010-lua-5.1.3-lnum-full-260308.patch
diff --git a/package/utils/lua/patches/011-lnum-use-double.patch b/package/utils/lua5.1/patches/011-lnum-use-double.patch
similarity index 100%
rename from package/utils/lua/patches/011-lnum-use-double.patch
rename to package/utils/lua5.1/patches/011-lnum-use-double.patch
diff --git a/package/utils/lua/patches/012-lnum-fix-ltle-relational-operators.patch b/package/utils/lua5.1/patches/012-lnum-fix-ltle-relational-operators.patch
similarity index 100%
rename from package/utils/lua/patches/012-lnum-fix-ltle-relational-operators.patch
rename to package/utils/lua5.1/patches/012-lnum-fix-ltle-relational-operators.patch
diff --git a/package/utils/lua/patches/013-lnum-strtoul-parsing-fixes.patch b/package/utils/lua5.1/patches/013-lnum-strtoul-parsing-fixes.patch
similarity index 100%
rename from package/utils/lua/patches/013-lnum-strtoul-parsing-fixes.patch
rename to package/utils/lua5.1/patches/013-lnum-strtoul-parsing-fixes.patch
diff --git a/package/utils/lua/patches/015-lnum-ppc-compat.patch b/package/utils/lua5.1/patches/015-lnum-ppc-compat.patch
similarity index 100%
rename from package/utils/lua/patches/015-lnum-ppc-compat.patch
rename to package/utils/lua5.1/patches/015-lnum-ppc-compat.patch
diff --git a/package/utils/lua/patches/020-shared_liblua.patch b/package/utils/lua5.1/patches/020-shared_liblua.patch
similarity index 100%
rename from package/utils/lua/patches/020-shared_liblua.patch
rename to package/utils/lua5.1/patches/020-shared_liblua.patch
diff --git a/package/utils/lua/patches/030-archindependent-bytecode.patch b/package/utils/lua5.1/patches/030-archindependent-bytecode.patch
similarity index 100%
rename from package/utils/lua/patches/030-archindependent-bytecode.patch
rename to package/utils/lua5.1/patches/030-archindependent-bytecode.patch
diff --git a/package/utils/lua/patches/040-use-symbolic-functions.patch b/package/utils/lua5.1/patches/040-use-symbolic-functions.patch
similarity index 100%
rename from package/utils/lua/patches/040-use-symbolic-functions.patch
rename to package/utils/lua5.1/patches/040-use-symbolic-functions.patch
diff --git a/package/utils/lua/patches/050-honor-cflags.patch b/package/utils/lua5.1/patches/050-honor-cflags.patch
similarity index 100%
rename from package/utils/lua/patches/050-honor-cflags.patch
rename to package/utils/lua5.1/patches/050-honor-cflags.patch
diff --git a/package/utils/lua/patches/100-no_readline.patch b/package/utils/lua5.1/patches/100-no_readline.patch
similarity index 100%
rename from package/utils/lua/patches/100-no_readline.patch
rename to package/utils/lua5.1/patches/100-no_readline.patch
diff --git a/package/utils/lua/patches/200-lua-path.patch b/package/utils/lua5.1/patches/200-lua-path.patch
similarity index 100%
rename from package/utils/lua/patches/200-lua-path.patch
rename to package/utils/lua5.1/patches/200-lua-path.patch
diff --git a/package/utils/lua/patches/300-opcode_performance.patch b/package/utils/lua5.1/patches/300-opcode_performance.patch
similarity index 100%
rename from package/utils/lua/patches/300-opcode_performance.patch
rename to package/utils/lua5.1/patches/300-opcode_performance.patch