diff --git a/package/base-files/files/etc/init.d/gpio_switch b/package/base-files/files/etc/init.d/gpio_switch
index 6b2dcdce4183..e1f86ac2b348 100755
--- a/package/base-files/files/etc/init.d/gpio_switch
+++ b/package/base-files/files/etc/init.d/gpio_switch
@@ -3,7 +3,6 @@
 
 START=94
 STOP=10
-USE_PROCD=1
 
 
 load_gpio_switch()
diff --git a/package/base-files/files/etc/init.d/system b/package/base-files/files/etc/init.d/system
index a98a9724691f..a94586916e4e 100755
--- a/package/base-files/files/etc/init.d/system
+++ b/package/base-files/files/etc/init.d/system
@@ -2,7 +2,6 @@
 # Copyright (C) 2014 OpenWrt.org
 
 START=10
-USE_PROCD=1
 
 validate_system_section()
 {
diff --git a/package/kernel/om-watchdog/files/om-watchdog.init b/package/kernel/om-watchdog/files/om-watchdog.init
index 4c407dadaeb7..e65bef9cb0ce 100644
--- a/package/kernel/om-watchdog/files/om-watchdog.init
+++ b/package/kernel/om-watchdog/files/om-watchdog.init
@@ -6,7 +6,6 @@
 START=11
 STOP=11
 
-USE_PROCD=1
 NAME=om-watchdog
 PROG=/sbin/om-watchdog
 
diff --git a/package/network/config/firewall/files/firewall.init b/package/network/config/firewall/files/firewall.init
index ee3ed1a28356..05b1d28d7096 100755
--- a/package/network/config/firewall/files/firewall.init
+++ b/package/network/config/firewall/files/firewall.init
@@ -1,7 +1,6 @@
 #!/bin/sh /etc/rc.common
 
 START=19
-USE_PROCD=1
 QUIET=""
 
 validate_firewall_redirect()
diff --git a/package/network/config/ltq-adsl-app/files/dsl_control b/package/network/config/ltq-adsl-app/files/dsl_control
index 91fcb46beb82..0ab8d2b92628 100644
--- a/package/network/config/ltq-adsl-app/files/dsl_control
+++ b/package/network/config/ltq-adsl-app/files/dsl_control
@@ -2,7 +2,6 @@
 # Copyright (C) 2012 OpenWrt.org
 
 START=97
-USE_PROCD=1
 
 EXTRA_COMMANDS="status lucistat"
 EXTRA_HELP="	status  Get DSL status information
diff --git a/package/network/config/ltq-vdsl-app/files/dsl_control b/package/network/config/ltq-vdsl-app/files/dsl_control
index e62a5e558cf8..8c76469b4fce 100644
--- a/package/network/config/ltq-vdsl-app/files/dsl_control
+++ b/package/network/config/ltq-vdsl-app/files/dsl_control
@@ -2,7 +2,6 @@
 # Copyright (C) 2012 OpenWrt.org
 
 START=97
-USE_PROCD=1
 
 EXTRA_COMMANDS="status lucistat"
 EXTRA_HELP="	status  Get DSL status information
diff --git a/package/network/config/netifd/files/etc/init.d/network b/package/network/config/netifd/files/etc/init.d/network
index dc208c4ce0a1..5aeea68658d2 100755
--- a/package/network/config/netifd/files/etc/init.d/network
+++ b/package/network/config/netifd/files/etc/init.d/network
@@ -3,7 +3,6 @@
 START=20
 STOP=90
 
-USE_PROCD=1
 
 init_switch() {
 	setup_switch() { return 0; }
diff --git a/package/network/config/qos-scripts/files/etc/init.d/qos b/package/network/config/qos-scripts/files/etc/init.d/qos
index 712d906f03f9..bdb28d9de79b 100755
--- a/package/network/config/qos-scripts/files/etc/init.d/qos
+++ b/package/network/config/qos-scripts/files/etc/init.d/qos
@@ -2,7 +2,6 @@
 # Copyright (C) 2006 OpenWrt.org
 
 START=50
-USE_PROCD=1
 
 validate_qos_section()
 {
diff --git a/package/network/services/dnsmasq/files/dnsmasq.init b/package/network/services/dnsmasq/files/dnsmasq.init
index 1054f7a12a15..58b58893e31b 100644
--- a/package/network/services/dnsmasq/files/dnsmasq.init
+++ b/package/network/services/dnsmasq/files/dnsmasq.init
@@ -3,7 +3,6 @@
 
 START=19
 
-USE_PROCD=1
 PROG=/usr/sbin/dnsmasq
 
 ADD_LOCAL_DOMAIN=1
diff --git a/package/network/services/dropbear/files/dropbear.init b/package/network/services/dropbear/files/dropbear.init
index 173ab0928528..a704ce711a67 100755
--- a/package/network/services/dropbear/files/dropbear.init
+++ b/package/network/services/dropbear/files/dropbear.init
@@ -5,7 +5,6 @@
 START=19
 STOP=50
 
-USE_PROCD=1
 PROG=/usr/sbin/dropbear
 NAME=dropbear
 PIDCOUNT=0
diff --git a/package/network/services/igmpproxy/files/igmpproxy.init b/package/network/services/igmpproxy/files/igmpproxy.init
index c4af43068145..d53f1cf85522 100644
--- a/package/network/services/igmpproxy/files/igmpproxy.init
+++ b/package/network/services/igmpproxy/files/igmpproxy.init
@@ -2,7 +2,6 @@
 # Copyright (C) 2010-2014 OpenWrt.org
 
 START=99
-USE_PROCD=1
 PROG=/usr/sbin/igmpproxy
 CONFIGFILE=/var/etc/igmpproxy.conf
 
diff --git a/package/network/services/ipset-dns/files/ipset-dns.init b/package/network/services/ipset-dns/files/ipset-dns.init
index 0a76fcc4cd17..14a985d18592 100755
--- a/package/network/services/ipset-dns/files/ipset-dns.init
+++ b/package/network/services/ipset-dns/files/ipset-dns.init
@@ -3,7 +3,6 @@
 
 START=61
 
-USE_PROCD=1
 
 find_nameserver() {
 	. /lib/functions/network.sh
diff --git a/package/network/services/lldpd/files/lldpd.init b/package/network/services/lldpd/files/lldpd.init
index 9fb3a8255995..89c2d83e6a40 100644
--- a/package/network/services/lldpd/files/lldpd.init
+++ b/package/network/services/lldpd/files/lldpd.init
@@ -4,7 +4,6 @@
 START=90
 STOP=01
 
-USE_PROCD=1
 LLDPCLI=/usr/sbin/lldpcli
 LLDPSOCKET=/var/run/lldpd.socket
 LLDPD_CONF=/tmp/lldpd.conf
diff --git a/package/network/services/odhcpd/files/odhcpd.init b/package/network/services/odhcpd/files/odhcpd.init
index e05c3860c41e..9274c9aa09dd 100644
--- a/package/network/services/odhcpd/files/odhcpd.init
+++ b/package/network/services/odhcpd/files/odhcpd.init
@@ -2,7 +2,6 @@
 
 START=35
 STOP=85
-USE_PROCD=1
 
 start_service() {
 	procd_open_instance
diff --git a/package/network/services/omcproxy/files/omcproxy.init b/package/network/services/omcproxy/files/omcproxy.init
index 757b7794ef3c..3f211c7f223f 100644
--- a/package/network/services/omcproxy/files/omcproxy.init
+++ b/package/network/services/omcproxy/files/omcproxy.init
@@ -2,7 +2,6 @@
 # Copyright (C) 2018 OpenWrt.org
 
 START=99
-USE_PROCD=1
 PROG=/usr/sbin/omcproxy
 
 # Uncomment to enable verbosity
diff --git a/package/network/services/openvpn/files/openvpn.init b/package/network/services/openvpn/files/openvpn.init
index a7d35d1a985e..cc5a871e001a 100644
--- a/package/network/services/openvpn/files/openvpn.init
+++ b/package/network/services/openvpn/files/openvpn.init
@@ -7,7 +7,6 @@
 START=90
 STOP=10
 
-USE_PROCD=1
 PROG=/usr/sbin/openvpn
 
 LIST_SEP="
diff --git a/package/network/services/relayd/files/relay.init b/package/network/services/relayd/files/relay.init
index 5c7a0f9efe60..cce4c594a676 100644
--- a/package/network/services/relayd/files/relay.init
+++ b/package/network/services/relayd/files/relay.init
@@ -3,7 +3,6 @@
 
 START=80
 
-USE_PROCD=1
 PROG=/usr/sbin/relayd
 
 validate_proto_relayd()
diff --git a/package/network/services/samba36/files/samba.init b/package/network/services/samba36/files/samba.init
index abe8e8f5c714..053ae6d48b69 100755
--- a/package/network/services/samba36/files/samba.init
+++ b/package/network/services/samba36/files/samba.init
@@ -2,7 +2,6 @@
 # Copyright (C) 2008-2012 OpenWrt.org
 
 START=60
-USE_PROCD=1
 
 smb_header() {
 	config_get samba_iface $1 interface "loopback lan"
diff --git a/package/network/services/uhttpd/files/uhttpd.init b/package/network/services/uhttpd/files/uhttpd.init
index dc496b3e2829..b4bd3aa3445c 100755
--- a/package/network/services/uhttpd/files/uhttpd.init
+++ b/package/network/services/uhttpd/files/uhttpd.init
@@ -3,7 +3,6 @@
 
 START=50
 
-USE_PROCD=1
 
 UHTTPD_BIN="/usr/sbin/uhttpd"
 PX5G_BIN="/usr/sbin/px5g"
diff --git a/package/network/services/umdns/files/umdns.init b/package/network/services/umdns/files/umdns.init
index c0b8cedd79b5..2c3e7aeab22b 100644
--- a/package/network/services/umdns/files/umdns.init
+++ b/package/network/services/umdns/files/umdns.init
@@ -3,7 +3,6 @@
 
 START=80
 
-USE_PROCD=1
 PROG=/usr/sbin/umdns
 IFACES=""
 
diff --git a/package/network/utils/linux-atm/files/br2684ctl b/package/network/utils/linux-atm/files/br2684ctl
index 6513dd38adff..3ea5fe31e002 100755
--- a/package/network/utils/linux-atm/files/br2684ctl
+++ b/package/network/utils/linux-atm/files/br2684ctl
@@ -1,7 +1,6 @@
 #!/bin/sh /etc/rc.common
 
 START=50
-USE_PROCD=1
 
 start_daemon() {
 	local cfg="$1"
diff --git a/package/system/fstools/files/blockd.init b/package/system/fstools/files/blockd.init
index a4ce57d40dbf..053cd1e6c45d 100755
--- a/package/system/fstools/files/blockd.init
+++ b/package/system/fstools/files/blockd.init
@@ -2,7 +2,6 @@
 
 START=80
 
-USE_PROCD=1
 PROG=/sbin/blockd
 
 service_triggers() {
diff --git a/package/system/rpcd/files/rpcd.init b/package/system/rpcd/files/rpcd.init
index 447133c67a5a..f4e5244cbaff 100755
--- a/package/system/rpcd/files/rpcd.init
+++ b/package/system/rpcd/files/rpcd.init
@@ -2,7 +2,6 @@
 
 START=12
 
-USE_PROCD=1
 NAME=rpcd
 PROG=/sbin/rpcd
 
diff --git a/package/system/ubox/files/log.init b/package/system/ubox/files/log.init
index 250f805b4406..5261faaa049f 100644
--- a/package/system/ubox/files/log.init
+++ b/package/system/ubox/files/log.init
@@ -6,7 +6,6 @@ START=12
 STOP=89
 PIDCOUNT=0
 
-USE_PROCD=1
 PROG=/sbin/logread
 
 validate_log_section()
diff --git a/package/system/urandom-seed/files/etc/init.d/urandom_seed b/package/system/urandom-seed/files/etc/init.d/urandom_seed
index 17d9c1340078..f99c95a02eda 100755
--- a/package/system/urandom-seed/files/etc/init.d/urandom_seed
+++ b/package/system/urandom-seed/files/etc/init.d/urandom_seed
@@ -1,7 +1,6 @@
 #!/bin/sh /etc/rc.common
 
 START=99
-USE_PROCD=1
 
 start_service() {
     procd_open_instance "urandom_seed"
diff --git a/package/system/urngd/files/urngd.init b/package/system/urngd/files/urngd.init
index 7531ca8f390c..e312c43beede 100644
--- a/package/system/urngd/files/urngd.init
+++ b/package/system/urngd/files/urngd.init
@@ -2,7 +2,6 @@
 
 START=00
 
-USE_PROCD=1
 NAME=urngd
 PROG=/sbin/urngd
 
diff --git a/package/utils/busybox/files/cron b/package/utils/busybox/files/cron
index ca04a0c1707e..74e0cb1a2427 100755
--- a/package/utils/busybox/files/cron
+++ b/package/utils/busybox/files/cron
@@ -3,7 +3,6 @@
 
 START=50
 
-USE_PROCD=1
 PROG=/usr/sbin/crond
 
 validate_cron_section() {
diff --git a/package/utils/busybox/files/sysntpd b/package/utils/busybox/files/sysntpd
index 52866ba32acd..534dc5ecc9d0 100755
--- a/package/utils/busybox/files/sysntpd
+++ b/package/utils/busybox/files/sysntpd
@@ -3,7 +3,6 @@
 
 START=98
 
-USE_PROCD=1
 PROG=/usr/sbin/ntpd
 HOTPLUG_SCRIPT=/usr/sbin/ntpd-hotplug
 
diff --git a/package/utils/ct-bugcheck/src/bugcheck.initd b/package/utils/ct-bugcheck/src/bugcheck.initd
index b97a415bbfb9..d1eeb6615f68 100644
--- a/package/utils/ct-bugcheck/src/bugcheck.initd
+++ b/package/utils/ct-bugcheck/src/bugcheck.initd
@@ -3,7 +3,6 @@
 
 START=99
 
-USE_PROCD=1
 PROG=/usr/bin/bugchecker.sh
 
 # To actually make bugchecker.sh run, see comments
diff --git a/package/utils/mdadm/files/mdadm.init b/package/utils/mdadm/files/mdadm.init
index 64a50b35de27..acb5342b74ac 100644
--- a/package/utils/mdadm/files/mdadm.init
+++ b/package/utils/mdadm/files/mdadm.init
@@ -3,7 +3,6 @@
 START=13
 STOP=98
 
-USE_PROCD=1
 PROG=/sbin/mdadm
 NAME=mdadm
 
diff --git a/package/utils/ugps/files/ugps.init b/package/utils/ugps/files/ugps.init
index 3cd1ca1b8d2d..0615f022aefd 100644
--- a/package/utils/ugps/files/ugps.init
+++ b/package/utils/ugps/files/ugps.init
@@ -3,7 +3,6 @@
 
 START=80
 
-USE_PROCD=1
 PROG=/usr/sbin/ugps
 
 service_triggers() {
diff --git a/package/utils/usbmode/files/usbmode.init b/package/utils/usbmode/files/usbmode.init
index 43e8ec564d8d..d4b8dcf1a326 100755
--- a/package/utils/usbmode/files/usbmode.init
+++ b/package/utils/usbmode/files/usbmode.init
@@ -2,7 +2,6 @@
 # Copyright (C) 2013 OpenWrt.org
 
 START=20
-USE_PROCD=1
 
 start_service()
 {